glibmm: Gio::FilterInputStream Class Reference

glibmm 2.82.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::FilterInputStream Class Reference
Stream Classes

Filter Input Stream. More...

`#include <giomm/filterinputstream.h>`

Inheritance diagram for Gio::FilterInputStream:
[legend]

## Public Member Functions
| FilterInputStream (FilterInputStream &&src) noexcept
FilterInputStream & | operator= (FilterInputStream &&src) noexcept
| ~FilterInputStream () noexcept override
GFilterInputStream * | gobj ()
| Provides access to the underlying C GObject.
const GFilterInputStream * | gobj () const
| Provides access to the underlying C GObject.
GFilterInputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< InputStream > | get_base_stream ()
| Gets the base stream for the filter stream.
Glib::RefPtr< const InputStream > | get_base_stream () const
| Gets the base stream for the filter stream.
bool | get_close_base_stream () const
| Returns whether the base stream will be closed when stream is closed.
void | set_close_base_stream (bool close_base=true)
| Sets whether the base stream will be closed when stream is closed.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InputStream > > | property_base_stream () const
| The underlying base stream on which the I/O ops will be done.
Glib::PropertyProxy< bool > | property_close_base_stream ()
| Whether the base stream should be closed when the filter stream is closed.
Glib::PropertyProxy_ReadOnly< bool > | property_close_base_stream () const
| Whether the base stream should be closed when the filter stream is closed.
Public Member Functions inherited from Gio::InputStream
| InputStream (InputStream &&src) noexcept
InputStream & | operator= (InputStream &&src) noexcept
| ~InputStream () noexcept override
GInputStream * | gobj ()
| Provides access to the underlying C GObject.
const GInputStream * | gobj () const
| Provides access to the underlying C GObject.
GInputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
gssize | read (void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
gssize | read (void *buffer, gsize count)
| A read() convenience overload.
bool | read_all (void *buffer, gsize count, gsize &bytes_read, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
bool | read_all (void *buffer, gsize count, gsize &bytes_read)
| A read_all() convenience overload.
Glib::RefPtr< Glib::Bytes > | read_bytes (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Like g_input_stream_read(), this tries to read count bytes from the stream in a blocking fashion.
void | read_bytes_async (gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes.
void | read_bytes_async (gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes.
Glib::RefPtr< Glib::Bytes > | read_bytes_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous stream read-into-Bytes operation.
gssize | skip (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to skip count bytes from the stream.
gssize | skip (gsize count)
| A skip() convenience overload.
bool | close (const Glib::RefPtr< Cancellable > &cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | read_async (void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
void | read_async (void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
gssize | read_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous stream read operation.
void | read_all_async (void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
void | read_all_async (void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
bool | read_all_finish (const Glib::RefPtr< AsyncResult > &result, gsize &bytes_read)
| Finishes an asynchronous stream read operation started with g_input_stream_read_all_async().
void | skip_async (gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
void | skip_async (gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
gssize | skip_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes a stream skip operation.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
gboolean | close_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async().
bool | is_closed () const
| Checks if an input stream is closed.
bool | has_pending () const
| Checks if an input stream has pending actions.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::InputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| FilterInputStream (const Glib::RefPtr< InputStream > &base_stream)
Protected Member Functions inherited from Gio::InputStream
| InputStream ()
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
virtual gssize | read_vfunc (void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
virtual gssize | skip_vfunc (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
virtual bool | close_vfunc (const Glib::RefPtr< Cancellable > &cancellable)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::FilterInputStream > | wrap (GFilterInputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Filter Input Stream.

This is a base class for input stream implementations that perform some kind of filtering operation on a base stream. & Typical examples of filtering operations are character set conversion, compression and byte order flipping.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ FilterInputStream() [1/2]

Gio::FilterInputStream::FilterInputStream | ( | FilterInputStream && | src | ) |
| noexcept

## ◆ ~FilterInputStream()

Gio::FilterInputStream::~FilterInputStream | ( |  | ) |
| overridenoexcept

## ◆ FilterInputStream() [2/2]

Gio::FilterInputStream::FilterInputStream | ( | const Glib::RefPtr< InputStream > & | base_stream | ) |
| explicitprotected

## Member Function Documentation

## ◆ get_base_stream() [1/2]

Glib::RefPtr< InputStream > Gio::FilterInputStream::get_base_stream | ( |  | ) |

Gets the base stream for the filter stream.

Returns
  A InputStream.

## ◆ get_base_stream() [2/2]

Glib::RefPtr< const InputStream > Gio::FilterInputStream::get_base_stream | ( |  | ) | const

Gets the base stream for the filter stream.

Returns
  A InputStream.

## ◆ get_close_base_stream()

bool Gio::FilterInputStream::get_close_base_stream | ( |  | ) | const

Returns whether the base stream will be closed when stream is closed.

Returns
  `true` if the base stream will be closed.

## ◆ get_type()

static GType Gio::FilterInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GFilterInputStream * Gio::FilterInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GFilterInputStream * Gio::FilterInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GFilterInputStream * Gio::FilterInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FilterInputStream & Gio::FilterInputStream::operator= | ( | FilterInputStream && | src | ) |
| noexcept

## ◆ property_base_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InputStream > > Gio::FilterInputStream::property_base_stream | ( |  | ) | const

The underlying base stream on which the I/O ops will be done.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_close_base_stream() [1/2]

Glib::PropertyProxy< bool > Gio::FilterInputStream::property_close_base_stream | ( |  | ) |

Whether the base stream should be closed when the filter stream is closed.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_close_base_stream() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::FilterInputStream::property_close_base_stream | ( |  | ) | const

Whether the base stream should be closed when the filter stream is closed.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_close_base_stream()

void Gio::FilterInputStream::set_close_base_stream | ( | bool | close_base = `true` | ) |

Sets whether the base stream will be closed when stream is closed.

Parameters

  close_base | `true` to close the base stream.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::FilterInputStream > wrap | ( | GFilterInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.